program gettable

  implicit none
  integer:: nshock, m, mmax, l, jp(8), ec, model, agrid
  real(8):: gini, temp1, mu, sig, coef, A, theta, output
  real(8):: delta, beta, irate, labor, wages
  real(8):: ststr, ststk, ststy, ststraa, ststkaa, ststyaa, t
  real(8):: aa, muaa, outputaa, amin, amax
  real(8):: xmeasure
  real(8) ::percent(8),pcum, dx, percenth(8)
  real(8), dimension(:), allocatable:: mgrid, F, Fmean, xcum, eval, st_dist
  real(8), dimension(:,:), allocatable:: F00, mgridc
  real(8), dimension(101):: Lrz=0.0
  integer:: in=10,out=20 ! File Unit
  character(15)::in_name="inpbig.txt",distin_name="distabig2.txt",out_name="gini2.txt",drin_name
  
  !write(*,100)
  !read(*,*) ec
  write(*,101)
  read(*,*) model
100 format('Economy (1=benchmark, 2=high variability) ')
101 format('Model   (1=Market, 2=Planner) ')
  
  if (model==1) then
     in_name="input.txt"
     distin_name="distA.txt"
     drin_name="deciA.out"
     out_name="table1.txt"
  elseif (model==2) then
     in_name="input.txt"
     distin_name="distA2.txt"
     drin_name="deciA2.out"
     out_name="table2.txt"
  else
     print*, "incorrect option"
     pause
     stop
  end if

  open(in,file=in_name,status='old')
  open(out,file=out_name)

  read(in,*) ! line
  read(in,*) ! model
  read(in,*) amin
  read(in,*) amax
  read(in,*) agrid
  read(in,*) beta
  read(in,*) A
  read(in,*) theta
  read(in,*) ! sig
  read(in,*) delta
  read(in,*) !aproxdr
  read(in,*) !mmax
  read(in,*) !aproxdis
  read(in,*) !r
  read(in,*) nshock
  allocate(eval(nshock),st_dist(nshock))
  read(in,*) (eval(m), m=1,nshock)
  do m=1,nshock
  read(in,*)
  end do

  labor=0.0
  do m=1,nshock
     read(in,*) st_dist(m)
     labor=labor+eval(m)*st_dist(m)
  end do
  close(in)

  call decgrid

  open(37,file=distin_name,status='old')
  read(37,*) mmax
  
  allocate(mgrid(mmax))
  allocate(F00(nshock,mmax))
  allocate(F(mmax))
  allocate(Fmean(mmax))
  allocate(xcum(mmax))
  
  
  do m=1,mmax
     read(37,*) mgrid(m), F00(:,m)
  end do
  close(37)


  F=sum(F00,dim=1)

  !accumulate assets
  xcum(1)=F(1)*mgrid(1)
  do m=2,mmax
     xcum(m)= xcum(m-1)+ (F(m)-F(m-1)) * (mgrid(m)+mgrid(m-1))/2.
  end do
  open(36,file='tempout.txt')
  do m=1,mmax
     write(36,'(3f14.8)') mgrid(m),F(m),xcum(m)
  end do
  close(36)
  
  data jp/20, 40, 60, 80, 90, 95, 99, 100/
  
  ! Get gini
  
  call getmean(mu)
  call getvar(mu,sig)
  
  
  temp1 = 0.
  do l=1,100
     t=l/100.
     do m=1,mmax
        if (F(m)>t) exit
     end do

     if (m>mmax) then
        Lrz(l+1)=Fmean(mmax)
     elseif (m>1) then
        Lrz(l+1)=Fmean(m-1)+0.5*(t-F(m-1))*(mgrid(m)+mgrid(m-1))
     else
        Lrz(l+1)=Fmean(1)
     end if
     temp1=temp1+0.01*(Lrz(l+1)+Lrz(l))/2.
  end do
  Lrz=Lrz/Fmean(mmax)
  temp1=temp1/Fmean(mmax)
  
  open(37,file='lrz.txt')
  write(37,*) lrz
  close(37)
  gini = 1.-temp1*2.
  coef = sig**0.5/mu
  
  
  ststr=(1/beta-1)*100.
  ststk=(((ststr/100.)+delta)/(a*theta*labor**(1-theta)))**(1./(theta-1))
  ststy=A*ststk**theta* labor**(1.-theta)  
  
  

  ststkaa=THETA/((1/beta-1)+DELTA)
  AA=1./(STSTKaa**theta *  labor**(1.-theta)  )
  ststyaa = aA* ststkaa**theta* labor**(1.-theta)  

  output=a * mu**theta * labor**(1.-theta)  
  irate=(a*theta*mu**(theta-1.) * labor**(1-theta) -delta)* 100.
  wages= a*(1.-theta)*mu**theta * labor**(-theta)
  muaa= ( (irate/100+delta) / (aa * theta * labor**(1-theta)))**(1&
       &/(theta-1))

  outputaa=aa * muaa**theta * labor**(1.-theta)  


  call getpercent

  call wroutput
  close(out)


contains
  
  subroutine decgrid
    
    implicit none
    integer:: nn, m1, m2, amax1, amax2
    real(8):: amintemp, amaxtemp, temp
    real(8),dimension(:),allocatable::agrid1,agrid2,agridt
    
    
    amax1=agrid/2
    amax2=agrid-amax1
    allocate(agrid1(amax1),agrid2(amax2),agridt(agrid))
    
    do nn=1,amax1
       agrid1(nn)=amin+(amax-amin)*(nn-1)/(amax1-1)
    end do
    do nn=1,amax2
       agrid2(nn)=dsqrt(amax-amin)*(nn-1)/(amax2-1)
    end do
    agrid2=amin+agrid2**2.
    agrid2(amax2)=amax
    agrid2(1)=amin
    
    m1=1;m2=1
    
    do nn=1,amax1+amax2
       if (agrid1(m1)>agrid2(m2)) then
          agridt(nn)=agrid2(m2)
          m2=m2+1
       elseif (agrid1(m1)<agrid2(m2)) then
          agridt(nn)=agrid1(m1)
          m1=m1+1
       else
          agridt(nn)=agrid1(m1)
          m1=m1+1
          m2=m2+1
       end if
       agrid=nn
       if (m1>amax1 .or. m2>amax2) exit
    end do
    agridt(1)=amin
    agridt(agrid)=amax
    
    
    
    !allocate(a(agrid));a=0.0
    !a=agridt(1:agrid)
    

  end subroutine decgrid

  !*************************************************************
  ! Get Mean
  !*************************************************************

  subroutine getmean(tk)

    implicit none
    integer::m
    real(8),intent(out)::tk

    tk=F(1)*mgrid(1)
    Fmean(1)=tk
    do m=1,mmax-1
       tk=tk+0.5*(F(m+1)-F(m))*(mgrid(m)+mgrid(m+1))
       Fmean(m+1)=tk
    end do

  end subroutine getmean

  !*************************************************************
  ! Get Var
  !*************************************************************

  subroutine getvar(avgk,tk)

    implicit none
    integer::m
    real(8):: avgk
    real(8),intent(out)::tk

    tk=F(1)*(mgrid(1)-avgk)**2.
    do m=1,mmax-1
       tk=tk+(F(m+1)-F(m))*((mgrid(m)+mgrid(m+1))/2.-avgk)**2.
    end do

  end subroutine getvar

  !*************************************************************
  ! Get percentiles
  !*************************************************************
  subroutine getpercent

    implicit none
    integer:: m,ip,ix,i

    xmeasure=F(mmax)
    percent(8)=xcum(mmax)
    do ip=1,7
       i=2
       dx=dble(jp(ip)*xmeasure/100.0d0)
       do ix=i,mmax
          if (F(ix) .ge. dx) then
             call interpo1 (F(ix-1),F(ix),xcum(ix-1), &
                  &               xcum(ix),dx,percent(ip)) 
             i=ix
             print 21,ix,dx,percent(ip) ,xcum(ix)/xcum(mmax)
             exit
          endif
       end do
    end do
21 format(1x,'ix',i5,' dx',f12.6,' %(ip) ',f18.6,' xcumrel',f12.6)

!    do ip=1,mmax
!       write(out,22)F(ip),xcum(ip)/xcum(mmax)
!    end do
22  format(1x,2f12.8)


    do ip=1,8
       percent(ip)=(percent(ip)/percent(8))*100.
    end do
    
    percenth(1)=percent(1)
    do  ip=2,4
       percenth(ip)=percent(ip)-percent(ip-1)
    end do
    percenth(5)=100.-sum(percenth(1:4))
    percenth(6)=percent(6)-percent(5) !90-95
    percenth(7)=percent(7)-percent(6) !95-99
    percenth(8)=percent(8)-percent(7) !99-100
    


    return
  end subroutine getpercent


  !*************************************************************
  ! Output to file
  !*************************************************************
  subroutine wroutput
    implicit none

    write(out,41) gini, coef
    write(out,42) mu, sig
    write(out,43) output, mu/output
    write(out,47) muaa, outputaa
    write(out,48)  outputaa, muaa/ outputaa
    write(out,44) irate, aa
    write(out,45) ststr, ststkaa
    write(out,46) ststyaa, ststk/ststy

    write(out,50)
    write(out,52)
    write(out,53)
    write(out,54)percenth
    write(out,*)'% ', sum(percenth)


41    format ("% Gini    = ", f10.5, 3x,   "coef(=sd/mean) = ", f10.5)
42    format ("% Mean    = ", f10.5, 3x,   "Var            = ", f12.5)
43    format ("% Output  = ", f10.5, 3x,   "Capital/output = ", f12.5)
47    format ("% muaa    = ", f10.5, 3x,   "outputaa       = ", f12.5)
48    format ("% outputaa= ", f10.5, 3x,   "capaa/outputaa = ", f12.5)
44    format ("% irate   = ", f10.5,'%',2x,"AA             = ", f12.5)
45    format ("% ststr   = ", f10.5,'%',2x,"ststCapital    = ", f12.5)
46    format ("% ststy   = ", f10.5, 3x,   "ststCap/out    = ", f12.5)
50    format ("%",/'%  DISTRIBUTION OF WEALTH LATEX READY',/)
51    format (/)
52    format ("%",8x,'           Quintiles               Top Groups')
53    format ("%",8x,'& 1st & 2nd & 3rd & 4th & 5th & 5-10& 1-5 & 1 ')
54    format ("%",8x,8f6.2)

  end subroutine wroutput
  !*************************************************************
  ! Linear interpolation
  !*************************************************************
  subroutine interpo1 (x1, x2, y1, y2, x, y)
    real(8):: x1, x2, y1,y2, x, y
    real(8):: a, b
  !!!!!!!!!!
    b = (y2-y1)/(x2-x1)
    a = y1-b*x1
    y = a+b*x
    return
  end subroutine interpo1
  !!!!!!!!!!

end program gettable
